/**************************************
****   INPUT.C  -  Input devices   ****
**************************************/

//-- Include Files -----------------------------------------------------------
#include <stdio.h>
#include <SDL.h>

//----------------------------------------------------------------------------
void Input_Init_Joysticks(void);
unsigned char read_player1(void);
unsigned char read_player2(void);
unsigned char read_pl12_startsel(void);

//----------------------------------------------------------------------------

extern void not_implemented(void);
extern int	neogeo_ipl_done;	

Uint8 * key;
SDL_Event event;
int num_joysticks;
SDL_Joystick	*joystick[4];
			
//----------------------------------------------------------------------------
void Input_Init_Joysticks(void)
{
	int i;
	
	num_joysticks=SDL_NumJoysticks();
	
	for(i=0;i<num_joysticks;i++)
		joystick[i]=SDL_JoystickOpen(i);

}




unsigned char	read_player1(void)
{
	unsigned char	k = 0xFF;

	SDL_PollEvent(&event);
	key = SDL_GetKeyState(NULL);

	if (key[SDLK_UP]||SDL_JoystickGetAxis(joystick[0],1)<-3000)
		k &= 0xFE;

	if (key[SDLK_DOWN]||SDL_JoystickGetAxis(joystick[0],1)>3000)
		k &= 0xFD;

	if (key[SDLK_LEFT]||SDL_JoystickGetAxis(joystick[0],0)<-3000)
		k &= 0xFB;

	if (key[SDLK_RIGHT]||SDL_JoystickGetAxis(joystick[0],0)>3000)
		k &= 0xF7;

	if (key[SDLK_LCTRL]||SDL_JoystickGetButton(joystick[0], 0))
		k &= 0xEF;

	if (key[SDLK_LALT]||SDL_JoystickGetButton(joystick[0], 1))
		k &= 0xDF;

	if (key[SDLK_SPACE]||SDL_JoystickGetButton(joystick[0], 2))
		k &= 0xBF;

	if (key[SDLK_LSHIFT]||SDL_JoystickGetButton(joystick[0], 3))
		k &= 0x7F;	

	return	k;
}

//----------------------------------------------------------------------------
unsigned char	read_player2(void)
{
	unsigned char	k = 0xFF;

	/*SDL_PollEvent(&event);
	key = SDL_GetKeyState(NULL);*/

	if (SDL_JoystickGetAxis(joystick[1],1)<-3000)
		k &= 0xFE;

	if (SDL_JoystickGetAxis(joystick[1],1)>3000)
		k &= 0xFD;

	if (SDL_JoystickGetAxis(joystick[1],0)<-3000)
		k &= 0xFB;

	if (SDL_JoystickGetAxis(joystick[1],0)>3000)
		k &= 0xF7;

	if (SDL_JoystickGetButton(joystick[1], 0))
		k &= 0xEF;

	if (SDL_JoystickGetButton(joystick[1], 1))
		k &= 0xDF;

	if (SDL_JoystickGetButton(joystick[1], 2))
		k &= 0xBF;

	if (SDL_JoystickGetButton(joystick[1], 3))
		k &= 0x7F;	

	return	k;
}

//----------------------------------------------------------------------------
unsigned char	read_pl12_startsel(void)
{
	char	k = 0x0F;

	SDL_PollEvent(&event);
	key = SDL_GetKeyState(NULL);	

	if (key[SDLK_1]||SDL_JoystickGetButton(joystick[0], 8))
		k &= 0xFE;
		
	if (key[SDLK_5]||SDL_JoystickGetButton(joystick[0], 9))
		k &= 0xFD;

	if (key[SDLK_2]||SDL_JoystickGetButton(joystick[1], 8))
		k &= 0xFB;
		
	if (key[SDLK_6]||SDL_JoystickGetButton(joystick[1], 9))
		k &= 0xF7;

	return k;
}
